summaryrefslogtreecommitdiffstats
path: root/libraries/flint
diff options
context:
space:
mode:
author R. Jesus <rj dot bcjesus at gmail dot com>2020-10-09 12:10:58 +0100
committer Willy Sudiarto Raharjo <willysr@slackbuilds.org>2020-10-10 10:18:49 +0700
commitcf80d2d5f0395ec83512858862ffe44b2c8130fd (patch)
treed1d2242549cb36883c176167df183369f2b71422 /libraries/flint
parented57e8135aa2a612c049ba54d7aee08dc2b2bb8e (diff)
downloadslackbuilds-cf80d2d5f0395ec83512858862ffe44b2c8130fd.tar.gz
slackbuilds-cf80d2d5f0395ec83512858862ffe44b2c8130fd.tar.xz
libraries/flint: Added (Fast Library for Number Theory)
Signed-off-by: Dave Woodfall <dave@slackbuilds.org> Signed-off-by: Willy Sudiarto Raharjo <willysr@slackbuilds.org>
Diffstat (limited to 'libraries/flint')
-rw-r--r--libraries/flint/README14
-rw-r--r--libraries/flint/flint.SlackBuild106
-rw-r--r--libraries/flint/flint.info10
-rw-r--r--libraries/flint/slack-desc19
4 files changed, 149 insertions, 0 deletions
diff --git a/libraries/flint/README b/libraries/flint/README
new file mode 100644
index 0000000000..39a3a1a4cd
--- /dev/null
+++ b/libraries/flint/README
@@ -0,0 +1,14 @@
+FLINT (Fast Library for Number Theory) is a C library in support of
+computations in number theory. It's also a research project into
+algorithms in number theory.
+
+FLINT supports arithmetic with numbers, polynomials, power series and
+matrices over many base rings, including:
+ * Multiprecision integers and rationals
+ * Integers modulo n
+ * p-adic numbers
+ * Finite fields (prime and non-prime order)
+ * Real and complex numbers (via the Arb extension library)
+
+FLINT was licensed GPL v2+ up to and including version 2.5. New version
+are licensed LGPL v2.1+.
diff --git a/libraries/flint/flint.SlackBuild b/libraries/flint/flint.SlackBuild
new file mode 100644
index 0000000000..2de9eaa2a1
--- /dev/null
+++ b/libraries/flint/flint.SlackBuild
@@ -0,0 +1,106 @@
+#!/bin/sh
+
+# Slackware build script for FLINT
+
+# Copyright 2020, R. Jesus, Portugal
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+PRGNAM=flint
+VERSION=${VERSION:-2.6.3}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+
+# Automatically determine the architecture we're building on:
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i586 ;;
+ arm*) ARCH=arm ;;
+ # Unless $ARCH is already set, use uname -m for all other archs:
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+CWD=$(pwd)
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+if [ "$ARCH" = "i586" ]; then
+ SLKCFLAGS="-O2 -march=i586 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+set -e # Exit on most errors
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $PRGNAM-$VERSION
+tar xvf $CWD/$PRGNAM-$VERSION.tar.gz
+cd $PRGNAM-$VERSION
+chown -R root:root .
+find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
+ -o -perm 511 \) -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
+ -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;
+
+CFLAGS="$SLKCFLAGS" \
+CXXFLAGS="$SLKCFLAGS" \
+./configure \
+ --prefix=/usr \
+ --disable-static \
+ --build=$ARCH-slackware-linux
+
+# Compile the application and install it into the $PKG directory
+make
+make install DESTDIR=$PKG
+
+# FLINT doesn't have an option to set the library path, so we adjust it here
+test -z "$LIBDIRSUFFIX" || mv -v "$PKG/usr/lib" "$PKG/usr/lib${LIBDIRSUFFIX}"
+
+# Strip binaries and libraries - this can be done with 'make install-strip'
+# in many source trees, and that's usually acceptable if so, but if not,
+# use this:
+find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+# Copy program documentation into the package
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -av doc/. $PKG/usr/doc/$PRGNAM-$VERSION/
+cp -av examples $PKG/usr/doc/$PRGNAM-$VERSION/
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+# Copy the slack-desc into ./install
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+
+# Make the package; be sure to leave it in $OUTPUT
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.${PKGTYPE:-tgz}
diff --git a/libraries/flint/flint.info b/libraries/flint/flint.info
new file mode 100644
index 0000000000..3226b5adf1
--- /dev/null
+++ b/libraries/flint/flint.info
@@ -0,0 +1,10 @@
+PRGNAM="flint"
+VERSION="2.6.3"
+HOMEPAGE="http://www.flintlib.org/"
+DOWNLOAD="http://www.flintlib.org/flint-2.6.3.tar.gz"
+MD5SUM="ed3a6cab37fe2298d9cfaead6ccd1dc7"
+DOWNLOAD_x86_64=""
+MD5SUM_x86_64=""
+REQUIRES=""
+MAINTAINER="R. Jesus"
+EMAIL="rj dot bcjesus at gmail dot com"
diff --git a/libraries/flint/slack-desc b/libraries/flint/slack-desc
new file mode 100644
index 0000000000..d470e3b5d5
--- /dev/null
+++ b/libraries/flint/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description.
+# Line up the first '|' above the ':' following the base package name, and
+# the '|' on the right side marks the last column you can put a character in.
+# You must make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+flint: FLINT: Fast Library for Number Theory
+flint:
+flint: FLINT (Fast Library for Number Theory) is a C library in support of
+flint: computations in number theory. It's also a research project into
+flint: algorithms in number theory.
+flint:
+flint: http://www.flintlib.org/
+flint:
+flint:
+flint:
+flint: